<template>

  <base-modal-form :show="isLoginModalActive" title="Microblog Login" @submit-login="getLoginData" @close="hideLoginModal">
  </base-modal-form>
  <base-modal-error :show="isError" title="An error occurred!" @close="handleError">
  </base-modal-error>


  <div class="container text-center">
      <h2>vue-microblog</h2>
        <!-- todo implement user settings handler -->
        <base-button button-type="nav-button" v-if="userIsAuthenticated">Settings</base-button>
        <base-button button-type="nav-button" v-else @click="showLoginModal">Login</base-button>
        <base-button button-type="nav-button" v-if="userIsAuthenticated" @click="logout">Logout</base-button>
        <!-- todo implement user registration handler -->
        <base-button button-type="nav-button" v-else>Register</base-button>
      <hr>
  </div>
</template>

<script>
import {mapActions} from "vuex";
export default {
  name: "TheHeader",
  data() {
    return {
      isLoginModalActive: false,
      isError: false,
      error: '',
    };
  },
  computed: {
    userIsAuthenticated() {
      return this.$store.getters['auth/getUserIsAuthenticated'];
    }
  },
  methods: {
    ...mapActions({
      loginHandler: 'auth/loginUserAction',
      logoutHandler: 'auth/logoutUserAction'
    }),
    showLoginModal() {
      // step #1 in login sequence - display login modal
      // triggered by @click on login button
      this.isLoginModalActive = true;
    },
    hideLoginModal() {
      // triggered when @close event is emitted by BaseModalForm
      this.isLoginModalActive = false;
    },
    async getLoginData(payload) {
      // step #2 in login sequence - get data from login modal
      // triggered in response to @submit-login event emit on BaseModal
      this.isLoginModalActive = false;
      try {
        await this.loginHandler({
          // run login handler implemented in vuex 'auth' module
          username: payload.username,
          password: payload.password,
        });
      } catch (err) {
        this.isError = true;
        this.error = err.message;
      }
    },
    handleError() {
      this.isError = false;
      this.error = '';
    },
    logout() {
      // run logout handler implemented in vuex 'auth' module
      this.logoutHandler();
    }
  },
}
</script>

<style scoped>
hr {
  width: 80%;
  margin: auto;
}

.container {
  margin-bottom: 1.5rem;
}


</style>
